;
;
;

;
; Directives of the assembleur
;
.686P
.MMX													;; to activate the mmx instructions
.XMM													;; to activate the sse+ instructions
.MODEL flat, stdcall
.STACK 4096

OPTION SCOPED
OPTION LJMP
OPTION CASEMAP:NONE


;
; INCLUDE FILES
;
INCLUDE \Masm32\INCLUDE\windows.inc
INCLUDE \Masm32\INCLUDE\kernel32.inc
INCLUDE \Masm32\INCLUDE\user32.inc
INCLUDE \Masm32\INCLUDE\gdi32.inc
INCLUDE \Masm32\INCLUDE\Comctl32.inc
INCLUDE \Masm32\INCLUDE\comdlg32.inc
;INCLUDE \Masm32\INCLUDE\ole32.inc
;INCLUDE \Masm32\INCLUDE\oleaut32.inc
;INCLUDE \Masm32\INCLUDE\winmm.inc
;INCLUDE \Masm32\INCLUDE\shell32.inc
;INCLUDE \Masm32\INCLUDE\ .inc
INCLUDE \MAsm32\INCLUDE\masm32.inc


;
; LIBRARIES FILES
;
INCLUDELIB \Masm32\LIB\kernel32.lib
INCLUDELIB \Masm32\LIB\user32.lib
INCLUDELIB \Masm32\LIB\gdi32.lib
INCLUDELIB \Masm32\LIB\Comctl32.lib
INCLUDELIB \Masm32\LIB\comdlg32.lib
;INCLUDELIB \Masm32\LIB\ole32.lib
;INCLUDELIB \Masm32\LIB\oleaut32.lib
;INCLUDELIB \Masm32\LIB\winmm.lib
;INCLUDELIB \Masm32\LIB\shell32.lib
;INCLUDELIB \Masm32\LIB\ .lib
INCLUDELIB \MAsm32\LIB\masm32.lib


;
; Prototypes
;
WinProc			PROTO :DWORD,:DWORD,:DWORD,:DWORD
DlgWinProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD


.CONST
;
; CONSTANTS
;

;
; the ressource identifiers
;
Rsrc_IDI_Icon_32				EQU 532

Rsrc_IDM_MainMenu				EQU 1000
Rsrc_IDM_Effect_00				EQU 1001
Rsrc_IDM_Effect_01				EQU 1002
Rsrc_IDM_Effect_02				EQU 1003
Rsrc_IDM_Effect_03				EQU 1004
Rsrc_IDM_Effect_04				EQU 1005
Rsrc_IDM_Effect_05				EQU 1006
Rsrc_IDM_Effect_06				EQU 1007
Rsrc_IDM_Effect_07				EQU 1008
Rsrc_IDM_Effect_08				EQU 1009
Rsrc_IDM_Effect_09				EQU 1010
Rsrc_IDM_Effect_10				EQU 1011
Rsrc_IDM_Effect_11				EQU 1012
Rsrc_IDM_Effect_12				EQU 1013
Rsrc_IDM_Effect_13				EQU 1014
Rsrc_IDM_Effect_14				EQU 1015
Rsrc_IDM_Effect_15				EQU 1016

Rsrc_IDM_Blur					EQU 1021
Rsrc_IDM_DBuffer				EQU 1022
Rsrc_IDM_Full					EQU 1023
Rsrc_IDM_Fps					EQU 1024
Rsrc_IDM_Stats					EQU 1025
Rsrc_IDM_Fusion				EQU 1026

Rsrc_IDM_Quit					EQU 1099

Rsrc_IDD_Insufficient			EQU 2100
Rsrc_IDC_Insufficient_C			EQU 2101
Rsrc_IDC_Sorry					EQU 2102
Rsrc_IDC_Time_To_Change			EQU 2103

Rsrc_IDD_Quit					EQU 2200
Rsrc_IDC_Quit_C				EQU 2201
Rsrc_IDC_Really_Quit			EQU 2202
Rsrc_IDC_Hmm_Yes				EQU 2203
Rsrc_IDC_Oh_No					EQU 2204

;
; MISC
;
Number_Of_Victims				EQU 1
Main_Process_Stack_Size			EQU 16
Size_Of_Structures_Area			EQU 1024*64				;; 64 kb


.DATA
;
; STRUCTURES DEFINITIONS
;

; structure to create/delete a memory instance
Mem_Info STRUCT
	Instance				DWORD ?						;; (align 16) for most used values
	Init_Size				DWORD ?
	Max_Size				DWORD ?
	Unused01				DWORD ?						;; necessary, if you want aligned structures...
Mem_Info ENDS

; structure to alloc/free a memory area
Mem_Area STRUCT
	Mem_Size				DWORD ?						;; (align 16) for most used values
	Pointer_To_Free		DWORD ?						;; needed to free the area
	Pointer				DWORD ?						;; (align 8) for values used often
	Real_Mem_Size			DWORD ?						;; can be used for a security zone
Mem_Area ENDS

; structure to alloc/free a memory area for a screen
Screen_Area STRUCT
	Screen_Size			DWORD ?						;; (align 16) for most used values
	Pointer_To_Free		DWORD ?						;; needed to free the area
	Pointer				DWORD ?						;; (align 8) for values used often
	Real_Screen_Size		DWORD ?						;; can be used for a security zone
; here, we add things corresponding specifically to screens
	Screen_Width_x4		DWORD ?						;; (align 16) for most used values (to avoid lot of shl x,2)
	Screen_Width			DWORD ?
	Screen_Height			DWORD ?						;; (align 8) for values used often
	Screen_Flags			DWORD ?
	Pointer_Face_Limits		DWORD ?						;; (align 16) for most used values
	Pointer_Dbuffer		DWORD ?
	Pointer_Zbuffer		DWORD ?						;; (align 8) for values used often
	Unused01				DWORD ?						;; necessary, if you want aligned structures...
Screen_Area ENDS

; structure concerning the infos of a single sprite
Sprite_Info STRUCT
	Sprite_Width			DWORD ?						;; (align 16) for most used values
	Sprite_Height			DWORD ?
	X_Position			DWORD ?						;; (align 8) for values used often
	Y_Position			DWORD ?
	Screen_Width_x4		DWORD ?						;; (align 16) for most used values (to avoid lot of shl x,2)
	Virtual_Height			DWORD ?
	Structure_Lenght		DWORD ?						;; (align 8) for values used often (needed to go to the sprite pixels)
	Transparent_Color		DWORD ?
	Sprite_Width_x4		DWORD ?						;; (align 16) for most used values (to avoid lot of shl x,2)
	Screen_Width_Complement	DWORD ?
	Sprite_Size_x4			DWORD ?						;; (align 8) for values used often
	Sprite_Size			DWORD ?
	Transparency_Level		DWORD ?						;; (align 16) for most used values (format 0,A,A,A)
	Unused01				DWORD ?						;; necessary, if you want aligned structures...
	X_Base				DWORD ?						;; (align 8) for values used often
	Y_Base				DWORD ?
Sprite_Info ENDS

; a structure to obtain the pointers related to a bmp file loaded in memory
Bmp_Pointers STRUCT
	Pointer_Bmp_Header		DWORD ?
	Pointer_Bmp_Info		DWORD ?
	Pointer_Bmp_Palette		DWORD ?
	Pointer_Bmp_Pixels		DWORD ?
Bmp_Pointers ENDS

;
Font_Header STRUCT
	Font_Height			DWORD ?
	Number_Of_Digit		DWORD ?
Font_Header ENDS


.DATA
;
; Variables
;
INCLUDE Font_LucidaCalligraphy_20_B.inc

App_Instance				DWORD ?
Dlg_Instance				DWORD ?

Pointer_Command_Line		DWORD 0
Pointer_Window				DWORD ?
Pointer_Main_Menu			DWORD ?
Pointer_Main_Process		DWORD ?
Pointer_DC_Screen			HDC ?
Pointer_DC_Compatible		DWORD ?
Pointer_DC_Temp			DWORD ?
Pointer_New_DIB			DWORD ?
Pointer_Obtained_Pixels		DWORD ?


;
; 2D variables
;
OS_Screen_Width			DWORD ?
OS_Screen_Height			DWORD ?
OS_Screen_Width_Half		DWORD ?
OS_Screen_Height_Half		DWORD ?

Bmp_Width					DWORD ?
Bmp_Height				DWORD ?

X_Mouse_Movment			DWORD 0
Y_Mouse_Movment			DWORD 0

Images_Counter				DWORD 0

Current_Victim				DWORD 0

X_Screen_Position			DWORD ?
Y_Screen_Position			DWORD ?
X_Screen_Position_01		DWORD ?
Y_Screen_Position_01		DWORD ?
X_Screen_Position_02		DWORD ?
Y_Screen_Position_02		DWORD ?
X_Screen_Position_03		DWORD ?
Y_Screen_Position_03		DWORD ?
X_Screen_Position_04		DWORD ?
Y_Screen_Position_04		DWORD ?
X_Screen_Position_05		DWORD ?
Y_Screen_Position_05		DWORD ?
X_Screen_Position_06		DWORD ?
Y_Screen_Position_06		DWORD ?
X_Screen_Position_07		DWORD ?
Y_Screen_Position_07		DWORD ?
X_Screen_Position_08		DWORD ?
Y_Screen_Position_08		DWORD ?

Bmp_List					DWORD OFFSET str_Bmp01FileName,OFFSET str_Bmp02FileName,OFFSET str_Bmp03FileName,OFFSET str_Bmp04FileName
						DWORD OFFSET str_Bmp05FileName,OFFSET str_Bmp06FileName,OFFSET str_Bmp07FileName,OFFSET str_Bmp08FileName


;
; some flags
;
Flag_Effect				DWORD 0
Flag_Fps					DWORD 1
Flag_FullScreen			BYTE 0
Flag_FullScreenChange		BYTE 0
Flag_DBuffer				BYTE 1
Flag_Fusion				BYTE 0
Flag_Stats				BYTE 1
Flag_Blur					BYTE 0
Flag_Main_Process			BYTE 1						;; 1=active, 0=end launched, -1=finished

Flag_LMB					BYTE ?
Flag_MMB					BYTE ?
Flag_RMB					BYTE ?

MP_Init_Effect_00			BYTE 1
MP_Init_Effect_01			BYTE 0
MP_Init_Effect_02			BYTE 0
MP_Init_Effect_03			BYTE 0
MP_Init_Effect_04			BYTE 0
MP_Init_Effect_05			BYTE 0
MP_Init_Effect_06			BYTE 0
MP_Init_Effect_07			BYTE 0
MP_Init_Effect_08			BYTE 0
MP_Init_Effect_09			BYTE 0
MP_Init_Effect_10			BYTE 0
MP_Init_Effect_11			BYTE 0
MP_Init_Effect_12			BYTE 0
MP_Init_Effect_13			BYTE 0
MP_Init_Effect_14			BYTE 0
MP_Init_Effect_15			BYTE 0


; strings
str_Display				BYTE "DISPLAY",0
str_WindowTitle			BYTE "Torture Her",0
str_WindowClass			BYTE "Unknown",0
str_Fps					BYTE "FPS : "
str_FpsNumber				BYTE 12 DUP(0h)
str_Bmp01FileName			BYTE "Celine.bmp",0
str_Bmp02FileName			BYTE " ",0
str_Bmp03FileName			BYTE " ",0
str_Bmp04FileName			BYTE " ",0
str_Bmp05FileName			BYTE " ",0
str_Bmp06FileName			BYTE " ",0
str_Bmp07FileName			BYTE " ",0
str_Bmp08FileName			BYTE " ",0


ALIGN 16
; structured variables
Mem_Instance				Mem_Info <?>
Backup_Screen				Screen_Area <?>
Backup_Screen_01			Screen_Area <?>
Backup_Screen_02			Screen_Area <?>
Backup_Screen_03			Screen_Area <?>
Backup_Screen_04			Screen_Area <?>
Backup_Screen_05			Screen_Area <?>
Backup_Screen_06			Screen_Area <?>
Backup_Screen_07			Screen_Area <?>
Backup_Screen_08			Screen_Area <?>
Work_Screen				Screen_Area <?>
Work_Screen_01				Screen_Area <?>
Work_Screen_02				Screen_Area <?>
Work_Screen_03				Screen_Area <?>
Work_Screen_04				Screen_Area <?>
Work_Screen_05				Screen_Area <?>
Work_Screen_06				Screen_Area <?>
Work_Screen_07				Screen_Area <?>
Work_Screen_08				Screen_Area <?>
Final_Screen				Screen_Area <?>
Structures_Area			Mem_Area <?>

Loaded_Bmp_Data			Mem_Area <?>
Loaded_Bmp_Pointers			Bmp_Pointers <?>
; structure BITMAPINFO (here decomposed)
Loaded_Bmp_Info			BITMAPINFOHEADER <?>
Loaded_Bmp_Info_RGB			RGBQUAD <?>

; structure BITMAPINFO (here decomposed)
Work_Screens_Bmp_Info		BITMAPINFOHEADER <?>	;; ) bmiHeader (BITMAPINFOHEADER) (3 Dwords + 2 Words + 6 Dwords) + bmiColors (RGBQUAD) (4 octets)
Work_Screens_Bmp_Info_RGB	RGBQUAD <?>			;; )

Window_Info				WNDCLASSEX <?>			;; 12 Dwords
Mouse_Position				POINT <?>

OS_Messages				MSG <?>				;; 5 Dwords + 2 Words


.CODE
;
; MACROS
;


.CODE
;
; The generic procedures used
;
INCLUDE GenericProcs.asm


.CODE
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * The procedures specifically created for the program
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

ALIGN 16
;
; update the structures to use the corresponding values
;
UpdateCurrentVictim PROC
		pushad

		and eax,000000007h								;; to ensure it will not exceed 7 (8 bmp possible)
		mov Current_Victim,eax
		mov edx,SIZEOF Screen_Area
		mul edx
		mov ecx,eax
; the backup used
		mov eax,SIZEOF Screen_Area
		mov esi,OFFSET Backup_Screen_01
		add esi,ecx
		mov edi,OFFSET Backup_Screen
		call CopyMemArea_Mmx
; the workscreen used
		mov eax,SIZEOF Screen_Area
		mov esi,OFFSET Work_Screen_01
		add esi,ecx
		mov edi,OFFSET Work_Screen
		call CopyMemArea_Mmx
; the position of the window
		mov ecx,Current_Victim
		shl ecx,3
		mov eax,OFFSET X_Screen_Position_01
		mov edx,OFFSET Y_Screen_Position_01
		mov eax,DWORD PTR [eax+ecx]
		mov edx,DWORD PTR [edx+ecx]
		mov X_Screen_Position,eax
		mov Y_Screen_Position,edx

		cmp Flag_FullScreen,1							;; full screen ?
		je Label02									;; then go to Label02
; update the window
		invoke SetWindowPos,Pointer_Window,HWND_TOP,X_Screen_Position,Y_Screen_Position,Backup_Screen.Screen_Width,Backup_Screen.Screen_Height,SWP_NOZORDER
; update the BITMAPINFO structure of our screen
		mov eax,Work_Screen.Screen_Width					;; ) changes corresponding to a window
		mov edx,Work_Screen.Screen_Height					;; )
		neg edx										;; ) (neg, so the first line is the top one)
		mov Work_Screens_Bmp_Info.biWidth,eax				;; )
		mov Work_Screens_Bmp_Info.biHeight,edx				;; )
Label02:
		popad
	ret
UpdateCurrentVictim ENDP


ALIGN 16
;
; evaluate the elapsed time
;
TestElapsedTime PROC HWndc:DWORD,uMsg2:DWORD,ElapsedTime:DWORD,dwtime:DWORD

		cmp ElapsedTime,1
		jne Label01
		pushad
		mov eax,Images_Counter
		mov esi,OFFSET str_FpsNumber
		call ConvertValToDec
		mov Images_Counter,0
		popad
Label01:
	ret
TestElapsedTime ENDP


ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Main Process
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
MainProcess PROC

		mov ebx,OFFSET Bmp_List
		xor ecx,ecx
MP_LoadingLoop:
		push ebx
		push ecx
;
; load the bmp file, and obtain the pixels
;
		mov ebx,DWORD PTR [ebx]							;; ) load the bmp
		mov ecx,OFFSET Loaded_Bmp_Pointers					;; )
		mov esi,OFFSET Mem_Instance						;; )
		mov edi,OFFSET Loaded_Bmp_Data					;; )
		call LoadBmpFile								;; )
		cmp eax,0										;; a problem ?
		jle MP_AvoidToGetPixels							;; then go to MP_AvoidToGetPixels

		mov ebx,(Bmp_Pointers PTR [ecx]).Pointer_Bmp_Info
; get the width and height of the DIB (Device Independant Bitmap)
		cmp (BITMAPINFOHEADER PTR [ebx]).biSize,SIZEOF BITMAPCOREHEADER	;; structure BITMAPCOREHEADER ?
		jne MP_ItUseBMI								;; if not, go to MP_ItUseBMI
; here, width and height are words
MP_ItUseBCH:
		movzx eax,(BITMAPCOREHEADER PTR [ebx]).bcWidth
		movzx edx,(BITMAPCOREHEADER PTR [ebx]).bcHeight
		mov Bmp_Width,eax
		mov Bmp_Height,edx
		jmp MP_BmpSizesDefined
; here, width and height are dwords
MP_ItUseBMI:
		mov eax,(BITMAPINFOHEADER PTR [ebx]).biWidth
		mov edx,(BITMAPINFOHEADER PTR [ebx]).biHeight
		test edx,edx									;; ) neg value ?
		jns MP_NoNeedToPositive							;; )
		neg edx
MP_NoNeedToPositive:
		mov Bmp_Width,eax								;; ) save the values
		mov Bmp_Height,edx								;; )
MP_BmpSizesDefined:
; fill a BITMAPINFO structure (for the loaded bitmap, it's necessary to obtain the pixels...)
		mov eax,Bmp_Width
		mov edx,Bmp_Height
		neg edx
		mov Loaded_Bmp_Info.biSize,SIZEOF BITMAPINFOHEADER
		mov Loaded_Bmp_Info.biWidth,eax
		mov Loaded_Bmp_Info.biHeight,edx
		mov Loaded_Bmp_Info.biPlanes,1
		mov Loaded_Bmp_Info.biBitCount,32
		mov Loaded_Bmp_Info.biCompression,BI_RGB
		mov Loaded_Bmp_Info.biSizeImage,0
		mov Loaded_Bmp_Info.biXPelsPerMeter,0
		mov Loaded_Bmp_Info.biYPelsPerMeter,0
		mov Loaded_Bmp_Info.biClrUsed,0
		mov Loaded_Bmp_Info.biClrImportant,0
; obtain the pixels from the loaded file, in OUR format... (yeah, i know... the following lines are not really asm code,
; but with the system used by windows, we don't really have the choice...)
		invoke CreateDC,ADDR str_Display,NULL,NULL,NULL
		mov Pointer_DC_Temp,eax
		invoke CreateCompatibleDC,Pointer_DC_Temp
		mov Pointer_DC_Compatible,eax
		invoke CreateDIBSection,Pointer_DC_Compatible,ADDR Loaded_Bmp_Info,DIB_RGB_COLORS,ADDR Pointer_Obtained_Pixels,NULL,NULL
		mov Pointer_New_DIB,eax
		invoke SelectObject,Pointer_DC_Compatible,Pointer_New_DIB
		invoke SetDIBitsToDevice,Pointer_DC_Compatible,NULL,NULL,Bmp_Width,Bmp_Height,NULL,NULL,NULL,Bmp_Height,Loaded_Bmp_Pointers.Pointer_Bmp_Pixels,Loaded_Bmp_Pointers.Pointer_Bmp_Info,DIB_RGB_COLORS
; create the backup area (will be filled with the pixels obtained)
		mov eax,Bmp_Width
		mov ebx,Bmp_Height
		mov esi,OFFSET Mem_Instance
		mov edi,OFFSET Backup_Screen
		call CreateScreenArea
; here, simply copy the lines of pixels
		mov eax,Backup_Screen.Screen_Size
		mov esi,Pointer_Obtained_Pixels
		mov edi,Backup_Screen.Pointer
		call CopyMemArea_Mmx
; now, suppress the dirty stuff from windows, we don't need it anymore...
		invoke DeleteObject,Pointer_New_DIB
		invoke DeleteDC,Pointer_DC_Compatible
		invoke DeleteDC,Pointer_DC_Temp
MP_AvoidToGetPixels:
; free the memory allocated by "LoadBmpFile"
		mov esi,OFFSET Mem_Instance
		mov edi,OFFSET Loaded_Bmp_Data
		call SuppressMemArea
; end of the loop
		pop ecx
		pop ebx
; the backup used
		mov eax,SIZEOF Screen_Area
		mov esi,OFFSET Backup_Screen
		mov edi,OFFSET Backup_Screen_01
		add edi,ecx
		call CopyMemArea_Mmx
		add ebx,DWORD
		add ecx,SIZEOF Screen_Area
		cmp ecx,(SIZEOF Screen_Area)*Number_Of_Victims
		jne MP_LoadingLoop


;
; calc the centered position of our screens (coz now we know the sizes of the bmps)
;
		mov ecx,OS_Screen_Width
		mov edx,OS_Screen_Height

		mov eax,ecx
		mov ebx,edx
		sub eax,Backup_Screen_01.Screen_Width
		sub ebx,Backup_Screen_01.Screen_Height
		sar eax,1
		sar ebx,1
		mov X_Screen_Position_01,eax
		mov Y_Screen_Position_01,ebx

		mov eax,ecx
		mov ebx,edx
		sub eax,Backup_Screen_02.Screen_Width
		sub ebx,Backup_Screen_02.Screen_Height
		sar eax,1
		sar ebx,1
		mov X_Screen_Position_02,eax
		mov Y_Screen_Position_02,ebx

		mov eax,ecx
		mov ebx,edx
		sub eax,Backup_Screen_03.Screen_Width
		sub ebx,Backup_Screen_03.Screen_Height
		sar eax,1
		sar ebx,1
		mov X_Screen_Position_03,eax
		mov Y_Screen_Position_03,ebx

		mov eax,ecx
		mov ebx,edx
		sub eax,Backup_Screen_04.Screen_Width
		sub ebx,Backup_Screen_04.Screen_Height
		sar eax,1
		sar ebx,1
		mov X_Screen_Position_04,eax
		mov Y_Screen_Position_04,ebx

		mov eax,ecx
		mov ebx,edx
		sub eax,Backup_Screen_05.Screen_Width
		sub ebx,Backup_Screen_05.Screen_Height
		sar eax,1
		sar ebx,1
		mov X_Screen_Position_05,eax
		mov Y_Screen_Position_05,ebx

		mov eax,ecx
		mov ebx,edx
		sub eax,Backup_Screen_06.Screen_Width
		sub ebx,Backup_Screen_06.Screen_Height
		sar eax,1
		sar ebx,1
		mov X_Screen_Position_06,eax
		mov Y_Screen_Position_06,ebx

		mov eax,ecx
		mov ebx,edx
		sub eax,Backup_Screen_07.Screen_Width
		sub ebx,Backup_Screen_07.Screen_Height
		sar eax,1
		sar ebx,1
		mov X_Screen_Position_07,eax
		mov Y_Screen_Position_07,ebx

		mov eax,ecx
		mov ebx,edx
		sub eax,Backup_Screen_08.Screen_Width
		sub ebx,Backup_Screen_08.Screen_Height
		sar eax,1
		sar ebx,1
		mov X_Screen_Position_08,eax
		mov Y_Screen_Position_08,ebx


;
; update default bmp
;
		mov eax,0										;; ) define the victim (the number of the bmp used -1)
		call UpdateCurrentVictim							;; )


;
; Set the new positions and sizes
;
		invoke SetWindowPos,Pointer_Window,HWND_TOP,X_Screen_Position,Y_Screen_Position,Backup_Screen.Screen_Width,Backup_Screen.Screen_Height,SWP_NOZORDER
; update the BITMAPINFO structure of our screen
		mov eax,Backup_Screen_01.Screen_Width				;; ) changes corresponding to a window (image size)
		mov edx,Backup_Screen_01.Screen_Height				;; )
		neg edx										;; ) (neg, so the first line is the top one)
		mov Work_Screens_Bmp_Info.biWidth,eax				;; )
		mov Work_Screens_Bmp_Info.biHeight,edx				;; )


;
; allocate the memory areas needed
;

; for all the work screens
		mov esi,OFFSET Mem_Instance
		xor ecx,ecx
MP_AllocAreas:
		mov eax,OFFSET Backup_Screen_01.Screen_Width			;; ) alloc a mem area for the work screen
		mov ebx,OFFSET Backup_Screen_01.Screen_Height		;; )
		mov eax,DWORD PTR [eax+ecx]						;; )
		mov ebx,DWORD PTR [ebx+ecx]						;; )
;		mov esi,OFFSET Mem_Instance						;; )
		mov edi,OFFSET Work_Screen_01						;; )
		add edi,ecx									;; )
		call CreateDBufferScreenArea						;; )
; end of the loop
		add ecx,SIZEOF Screen_Area
		cmp ecx,(SIZEOF Screen_Area)*Number_Of_Victims
		jne MP_AllocAreas

; the others areas
		mov eax,Size_Of_Structures_Area					;;	) alloc a mem area for the possible structures
;		mov esi,OFFSET Mem_Instance						;;	)
		mov edi,OFFSET Structures_Area					;;	)
		call AllocMemArea								;;	)
		mov eax,OS_Screen_Width							;; ) alloc a mem area for the final screen (only used if full screen)
		mov ebx,OS_Screen_Height							;; )
;		mov esi,OFFSET Mem_Instance						;; )
		mov edi,OFFSET Final_Screen						;; )
		call CreateScreenArea							;; )


;
; beginning of the main loop
;
MP_MainLoop:

		mov eax,Flag_Effect
		and eax,00000000Fh								;; to ensure a valid jump
		jmp DWORD PTR [MP_Table_Effects+eax*4]
.DATA
ALIGN 4
; here our table for the jump labels
MP_Table_Effects	DWORD MP_Effect_00
				DWORD MP_Effect_01
				DWORD MP_Effect_02
				DWORD MP_Effect_03
				DWORD MP_Effect_04
				DWORD MP_Effect_05
				DWORD MP_Effect_06
				DWORD MP_Effect_07
				DWORD MP_Effect_08
				DWORD MP_Effect_09
				DWORD MP_Effect_10
				DWORD MP_Effect_11
				DWORD MP_Effect_12
				DWORD MP_Effect_13
				DWORD MP_Effect_14
				DWORD MP_Effect_15
; here, the corresponding labels of the jumps
.CODE
;
; SHAKE HER (a simple scrolling)
;
MP_Effect_00:
INCLUDE Effect00.asm
		jmp MP_End_Effects

;
; BURN HER (alpha sprites)
;
MP_Effect_01:
INCLUDE Effect01.asm
		jmp MP_End_Effects

;
; FREZZE HER (filter + sprites)
;
MP_Effect_02:
INCLUDE Effect02.asm
		jmp MP_End_Effects

;
; INSULT HER (gfx string + mouse interaction)
;
MP_Effect_03:
INCLUDE Effect03.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_04:
INCLUDE Effect04.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_05:
INCLUDE Effect05.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_06:
INCLUDE Effect06.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_07:
INCLUDE Effect07.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_08:
INCLUDE Effect08.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_09:
INCLUDE Effect09.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_10:
INCLUDE Effect10.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_11:
INCLUDE Effect11.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_12:
INCLUDE Effect12.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_13:
INCLUDE Effect13.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_14:
INCLUDE Effect14.asm
		jmp MP_End_Effects

;
;
;
MP_Effect_15:
INCLUDE Effect15.asm
		jmp MP_End_Effects

; end of the possible effects
MP_End_Effects:


;
; Fusion with the previous screen
;
		cmp Flag_Fusion,0
		je MP_NoCombinedScreen
		mov edi,OFFSET Work_Screen
		call CombinePreviousScreen_Mmx
MP_NoCombinedScreen:


;
; Display the number of images per seconds
;
		cmp Flag_Stats,0
		je MP_NoStatsDisplay
; set the colors
		mov eax,0FFFFFF1Fh
		mov ebx,03F000000h
		call SetGfxStringColors
; display the string
		xor eax,eax
		xor ebx,ebx
		mov edx,OFFSET Font_LucidaCalligraphy_20_B
		mov esi,OFFSET str_Fps
		mov edi,OFFSET Work_Screen
		call DisplayGfxString_Mmx
MP_NoStatsDisplay:


;
; Screen resizing (only if it must be made)
;
		cmp Flag_FullScreen,1							;; full screen ?
		je MP_FullScreen								;; then go to MP_FullScreen, otherwise we send the Work_Screen to SetDIBitsToDevice

; window
		cmp Flag_FullScreenChange,0						;; window previously ?
		je MP_AvoidModif01								;; then avoid the screen modifications
; otherwise, set the new positions and sizes
		invoke SetWindowPos,Pointer_Window,HWND_TOP,X_Screen_Position,Y_Screen_Position,Work_Screen.Screen_Width,Work_Screen.Screen_Height,SWP_NOZORDER
; update the BITMAPINFO structure of our screen
		mov eax,Work_Screen.Screen_Width					;; ) changes corresponding to a window
		mov edx,Work_Screen.Screen_Height					;; )
		neg edx										;; ) (neg, so the first line is the top one)
		mov Work_Screens_Bmp_Info.biWidth,eax				;; )
		mov Work_Screens_Bmp_Info.biHeight,edx				;; )
		mov Flag_FullScreenChange,0						;; and set the corresponding flag
MP_AvoidModif01:
		cmp Flag_Blur,1
		jne MP_AvoidBlur01
		mov eax,Work_Screen.Screen_Width
		mov ebx,Work_Screen.Screen_Height
		sub eax,2
		sub ebx,2
		mov ecx,1
		mov edx,1
		mov edi,OFFSET Work_Screen
		call ScreenFilter_Blur_Mmx
MP_AvoidBlur01:
		invoke SetDIBitsToDevice,Pointer_DC_Screen,NULL,NULL,Work_Screen.Screen_Width,Work_Screen.Screen_Height,NULL,NULL,NULL,Work_Screen.Screen_Height,Work_Screen.Pointer,ADDR Work_Screens_Bmp_Info,DIB_RGB_COLORS
		jmp MP_NoFullScreen

MP_FullScreen:
; full screen
		cmp Flag_FullScreenChange,1						;; full screen previously ?
		je MP_AvoidModif02								;; then avoid the screen modifications
; otherwise, set the new positions and sizes
		invoke SetWindowPos,Pointer_Window,HWND_TOP,NULL,NULL,Final_Screen.Screen_Width,Final_Screen.Screen_Height,SWP_NOZORDER
; update the BITMAPINFO structure of our screen
		mov eax,Final_Screen.Screen_Width					;; ) changes corresponding to full screen
		mov edx,Final_Screen.Screen_Height					;; )
		neg edx										;; ) (neg, so the first line is the top one)
		mov Work_Screens_Bmp_Info.biWidth,eax				;; )
		mov Work_Screens_Bmp_Info.biHeight,edx				;; )
		mov Flag_FullScreenChange,1						;; and set the corresponding flag
MP_AvoidModif02:
		mov esi,OFFSET Work_Screen						;; ) stretch the Work_Screen to the Final_Screen
		mov edi,OFFSET Final_Screen						;; )
		call EnlargeScreenArea							;; )
		cmp Flag_Blur,1
		jne MP_AvoidBlur02
		mov eax,Final_Screen.Screen_Width
		mov ebx,Final_Screen.Screen_Height
		sub eax,2
		sub ebx,2
		mov ecx,1
		mov edx,1
		mov edi,OFFSET Final_Screen
		call ScreenFilter_Blur_Mmx
MP_AvoidBlur02:
		invoke SetDIBitsToDevice,Pointer_DC_Screen,NULL,NULL,Final_Screen.Screen_Width,Final_Screen.Screen_Height,NULL,NULL,NULL,Final_Screen.Screen_Height,Final_Screen.Pointer,ADDR Work_Screens_Bmp_Info,DIB_RGB_COLORS
MP_NoFullScreen:


;
; update the DBuffer (by disactivating this, it can speed up things (due to cache usage), but can generate a flicker effect...)
;
		cmp Flag_DBuffer,0
		je MP_NoDBuffer
		mov edi,OFFSET Work_Screen
		call UpdateDBuffer
MP_NoDBuffer:


;
; End of the main loop
;
		invoke Sleep,Flag_Fps
		inc Images_Counter
		cmp Flag_Main_Process,0
		jne MP_MainLoop


;
; free the mem areas
;
		mov esi,OFFSET Mem_Instance						;; ) the final screen
		mov edi,OFFSET Final_Screen						;; )
		call SuppressScreenArea							;; )
;		mov esi,OFFSET Mem_Instance						;;	) the structures area
		mov edi,OFFSET Structures_Area					;;	)
		call SuppressMemArea							;;	)
; all the backups and work screens
		xor ecx,ecx
MP_FreeAreas:
;		mov esi,OFFSET Mem_Instance						;; ) the work screen
		mov edi,OFFSET Work_Screen_01						;; )
		add edi,ecx									;; )
		call SuppressScreenArea							;; )
;		mov esi,OFFSET Mem_Instance						;;	) the backup screen
		mov edi,OFFSET Backup_Screen_01					;;	)
		add edi,ecx									;;	)
		call SuppressScreenArea							;;	)
; end of the loop
		add ecx,SIZEOF Screen_Area
		cmp ecx,(SIZEOF Screen_Area)*Number_Of_Victims
		jne MP_FreeAreas


;
; End of the main process
;
		mov Flag_Main_Process,-1							;; main process finished
		invoke SendMessage,WinProc,WM_CLOSE,NULL,NULL
;	ret
MainProcess ENDP


ALIGN 16
;
; here, we include the necessary procedure concerning windows's messages...
;
WinProc PROC HWnd:DWORD,Message:DWORD,WParam:DWORD,LParam:DWORD

		cmp Flag_Main_Process,-1							;; main process finished ?
		jne WP_NoEndMainProcess							;; if not, go to WP_NoEndMainProcess
		invoke DestroyWindow,HWnd
		invoke PostQuitMessage,NULL
		xor eax,eax
	ret
WP_NoEndMainProcess:

		mov eax,Message								;; put Message in eax (it's faster if there is a big number of test)


;
; Launching the end of the main process ?
;
		cmp eax,WM_DESTROY
		jne WP_NoStopMainProcess
		mov Flag_Main_Process,0
		xor eax,eax
	ret
WP_NoStopMainProcess:


;
; here the commands generated by the mouse on the menu/controls
;
		cmp eax,WM_COMMAND
		jne WP_NoCommands
		mov eax,WParam									;; put WParam in eax (it's faster if there is a big number of test)
;

; Effect00 ?
		cmp eax,Rsrc_IDM_Effect_00
		jne WP_NoEffect00
		mov Flag_Effect,0
		mov MP_Init_Effect_00,1
	ret
WP_NoEffect00:

; Effect01 ?
		cmp eax,Rsrc_IDM_Effect_01
		jne WP_NoEffect01
		mov Flag_Effect,1
		mov MP_Init_Effect_01,1
	ret
WP_NoEffect01:

; Effect02 ?
		cmp eax,Rsrc_IDM_Effect_02
		jne WP_NoEffect02
		mov Flag_Effect,2
		mov MP_Init_Effect_02,1
	ret
WP_NoEffect02:

; Effect03 ?
		cmp eax,Rsrc_IDM_Effect_03
		jne WP_NoEffect03
		mov Flag_Effect,3
		mov MP_Init_Effect_03,1
	ret
WP_NoEffect03:

; Effect04 ?
		cmp eax,Rsrc_IDM_Effect_04
		jne WP_NoEffect04
		mov Flag_Effect,4
		mov MP_Init_Effect_04,1
	ret
WP_NoEffect04:

; Effect05 ?
		cmp eax,Rsrc_IDM_Effect_05
		jne WP_NoEffect05
		mov Flag_Effect,5
		mov MP_Init_Effect_05,1
	ret
WP_NoEffect05:

; Effect06 ?
		cmp eax,Rsrc_IDM_Effect_06
		jne WP_NoEffect06
		mov Flag_Effect,6
		mov MP_Init_Effect_06,1
	ret
WP_NoEffect06:

; Effect07 ?
		cmp eax,Rsrc_IDM_Effect_07
		jne WP_NoEffect07
		mov Flag_Effect,7
		mov MP_Init_Effect_07,1
	ret
WP_NoEffect07:

; Effect08 ?
		cmp eax,Rsrc_IDM_Effect_08
		jne WP_NoEffect08
		mov Flag_Effect,8
		mov MP_Init_Effect_08,1
	ret
WP_NoEffect08:

; Effect09 ?
		cmp eax,Rsrc_IDM_Effect_09
		jne WP_NoEffect09
		mov Flag_Effect,9
		mov MP_Init_Effect_09,1
	ret
WP_NoEffect09:

; Effect10 ?
		cmp eax,Rsrc_IDM_Effect_10
		jne WP_NoEffect10
		mov Flag_Effect,10
		mov MP_Init_Effect_10,1
	ret
WP_NoEffect10:

; Effect11 ?
		cmp eax,Rsrc_IDM_Effect_11
		jne WP_NoEffect11
		mov Flag_Effect,11
		mov MP_Init_Effect_11,1
	ret
WP_NoEffect11:

; Effect12 ?
		cmp eax,Rsrc_IDM_Effect_12
		jne WP_NoEffect12
		mov Flag_Effect,12
		mov MP_Init_Effect_12,1
	ret
WP_NoEffect12:

; Effect13 ?
		cmp eax,Rsrc_IDM_Effect_13
		jne WP_NoEffect13
		mov Flag_Effect,13
		mov MP_Init_Effect_13,1
	ret
WP_NoEffect13:

; Effect14 ?
		cmp eax,Rsrc_IDM_Effect_14
		jne WP_NoEffect14
		mov Flag_Effect,14
		mov MP_Init_Effect_14,1
	ret
WP_NoEffect14:

; Effect15 ?
		cmp eax,Rsrc_IDM_Effect_15
		jne WP_NoEffect15
		mov Flag_Effect,15
		mov MP_Init_Effect_15,1
	ret
WP_NoEffect15:

;

; activate/disactivate the blur ?
		cmp eax,Rsrc_IDM_Blur
		jne WP_NoSwapBlur
WP_SwapBlur:
		xor Flag_Blur,1
; update menu
		cmp Flag_Blur,1
		je WP_SwapBlur1
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_Blur,MF_UNCHECKED
		jmp WP_SwapBlur0
WP_SwapBlur1:
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_Blur,MF_CHECKED
WP_SwapBlur0:
	ret
WP_NoSwapBlur:

; activate/disactivate the double buffer ?
		cmp eax,Rsrc_IDM_DBuffer
		jne WP_NoSwapDBuffer
WP_SwapDBuffer:
		xor Flag_DBuffer,1
; update menu
		cmp Flag_DBuffer,1
		je WP_SwapDBuffer1
		mov edi,OFFSET Work_Screen
		call CleanDBuffer_Mmx
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_DBuffer,MF_UNCHECKED
		jmp WP_SwapDBuffer0
WP_SwapDBuffer1:
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_DBuffer,MF_CHECKED
WP_SwapDBuffer0:
	ret
WP_NoSwapDBuffer:

; activate/disactivate the full screen ?
		cmp eax,Rsrc_IDM_Full
		jne WP_NoSwapFull
WP_SwapFull:
		xor Flag_FullScreen,1
; update menu
		cmp Flag_FullScreen,1
		je WP_SwapFull1
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_Full,MF_UNCHECKED
		jmp WP_SwapFull0
WP_SwapFull1:
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_Full,MF_CHECKED
WP_SwapFull0:
	ret
WP_NoSwapFull:

; activate/disactivate the fps limits ?
		cmp eax,Rsrc_IDM_Fps
		jne WP_NoSwapFps
WP_SwapFps:
		xor Flag_Fps,1
; update menu
		cmp Flag_Fps,1
		je WP_SwapFps1
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_Fps,MF_UNCHECKED
		jmp WP_SwapFps0
WP_SwapFps1:
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_Fps,MF_CHECKED
WP_SwapFps0:
	ret
WP_NoSwapFps:

; activate/disactivate the stats ?
		cmp eax,Rsrc_IDM_Stats
		jne WP_NoSwapStats
WP_SwapStats:
		xor Flag_Stats,1
; update menu
		cmp Flag_Stats,1
		je WP_SwapStats1
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_Stats,MF_UNCHECKED
		jmp WP_SwapStats0
WP_SwapStats1:
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_Stats,MF_CHECKED
WP_SwapStats0:
	ret
WP_NoSwapStats:

; activate/disactivate the screen fusion (actual and previous screen) ?
		cmp eax,Rsrc_IDM_Fusion
		jne WP_NoSwapFusion
WP_SwapFusion:
		xor Flag_Fusion,1
; update menu
		cmp Flag_Fusion,1
		je WP_SwapFusion1
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_Fusion,MF_UNCHECKED
		jmp WP_SwapFusion0
WP_SwapFusion1:
		invoke CheckMenuItem,Pointer_Main_Menu,Rsrc_IDM_Fusion,MF_CHECKED
WP_SwapFusion0:
	ret
WP_NoSwapFusion:

;

; quit ?
		cmp eax,Rsrc_IDM_Quit
		jne WP_NoQuit
WP_Quit:
;		invoke ShowCursor,TRUE
		invoke DialogBoxParam,Dlg_Instance,Rsrc_IDD_Quit,0,ADDR DlgWinProc,0
;		invoke ShowCursor,FALSE
	ret
WP_NoQuit:

	ret
WP_NoCommands:


;
; mouse state
;

;
		cmp eax,WM_LBUTTONDOWN
		jne WP_NoLMBD
		mov Flag_LMB,1
	ret
WP_NoLMBD:
;
		cmp eax,WM_LBUTTONUP
		jne WP_NoLMBU
		mov Flag_LMB,0
	ret
WP_NoLMBU:

;;
;		cmp eax,WM_LBUTTONDBLCLK
;		jne WP_NoDLMB
;
;	ret
;WP_NoDLMB:

;
		cmp eax,WM_MBUTTONDOWN
		jne WP_NoMMBD
		mov Flag_MMB,1
	ret
WP_NoMMBD:
;
		cmp eax,WM_MBUTTONUP
		jne WP_NoMMBU
		mov Flag_MMB,0
	ret
WP_NoMMBU:
;;
;		cmp eax,WM_MBUTTONDBLCLK
;		jne WP_NoDMMB
;
;	ret
;WP_NoDMMB:

;
		cmp eax,WM_RBUTTONDOWN
		jne WP_NoRMBD
		mov Flag_RMB,1
; get the positions x and y of the mouse
;		invoke SetCursorPos,OS_Screen_Width_Half,OS_Screen_Height_Half	;; (optional, for centered menu)
		invoke GetCursorPos,ADDR Mouse_Position
; display the menu
;		invoke ShowCursor,TRUE
		invoke TrackPopupMenuEx,Pointer_Main_Menu,TPM_CENTERALIGN,Mouse_Position.x,Mouse_Position.y,HWnd,NULL
;		invoke ShowCursor,FALSE
	ret
WP_NoRMBD:
;
		cmp eax,WM_RBUTTONUP
		jne WP_NoRMBU
		mov Flag_RMB,0
	ret
WP_NoRMBU:
;;
;		cmp eax,WM_RBUTTONDBLCLK
;		jne WP_NoDRMB
;
;	ret
;WP_NoDRMB:

;
		cmp eax,WM_MOUSEMOVE
		jne WP_NoMouseMov
; X
		mov eax,LParam
		and eax,00000FFFFh
		mov X_Mouse_Movment,eax
; Y
		mov eax,LParam
		shr eax,16
		mov Y_Mouse_Movment,eax
	ret
WP_NoMouseMov:
	


;
; the messages from keys
;

; a key pressed ?
		cmp eax,WM_KEYDOWN
		jne WP_NoKeyDown
		mov eax,WParam

; esc (quit) ?
		cmp eax,VK_ESCAPE
		je WP_Quit

; b (activate/disactivate the blur) ?
		cmp eax,VK_B
		je WP_SwapBlur

; d (activate/disactivate the double buffer) ?
		cmp eax,VK_D
		je WP_SwapDBuffer

; f (activate/disactivate the full screen) ?
		cmp eax,VK_F
		je WP_SwapFull

; l (activate/disactivate the fps limits) ?
		cmp eax,VK_L
		je WP_SwapFps

; s (activate/disactivate the stats) ?
		cmp eax,VK_S
		je WP_SwapStats

; u (activate/disactivate the screen fusion) ?
		cmp eax,VK_U
		je WP_SwapFusion

;; (activate/disactivate the ) ?
;		cmp eax,VK_
;		je WP_

	ret
WP_NoKeyDown:

;; a key released ?
;		cmp eax,WM_KEYUP
;		jne WP_NoKeyUp
;		mov eax,WParam
;
;
;
;	ret
;WP_NoKeyUp:


;
; and we finish with the default possibility
;
		invoke DefWindowProc,HWnd,Message,WParam,LParam
	ret
WinProc ENDP


ALIGN 16
;
; Messages for/from the dialog box
;
DlgWinProc PROC HWndDlg:HWND,Message:UINT,WParam:WPARAM,LParam:LPARAM
		mov eax,Message


		cmp eax,WM_COMMAND								;; a command ?
		jne DWP_NoCommands
		mov eax,WParam

;
; dialog box insufficient processor
;

; It's time to change...
		cmp eax,Rsrc_IDC_Time_To_Change
		jne DWP_NoTimeToChange
		invoke EndDialog,HWndDlg,0						;; close the dialog box
		invoke PostQuitMessage,NULL						;; and post the quit message
	ret
DWP_NoTimeToChange:

;
; dialog box quit the app ?
;

; hmm... yes
		cmp eax,Rsrc_IDC_Hmm_Yes
		jne DWP_NoHmmYes
		mov Flag_Main_Process,0							;; Initiate the end of the main process

		invoke EndDialog,HWndDlg,0						;; and close the dialog box
;		jmp End_FastExit
	ret
DWP_NoHmmYes:

; Oh... no !
		cmp eax,Rsrc_IDC_Oh_No
		jne DWP_NoOhNo
		invoke EndDialog,HWndDlg,0						;; simply close the dialog box
	ret
DWP_NoOhNo:


;
; and we finish with the default possibility
;
DWP_NoCommands:
		xor eax,eax
	ret
DlgWinProc ENDP



ALIGN 16
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
; *
; * Entry point of the program
; *
; * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
TortureHer:

;		invoke GetCurrentProcess
;		invoke SetPriorityClass,eax,HIGH_PRIORITY_CLASS
		invoke GetCommandLine
		mov Pointer_Command_Line,eax
		invoke GetModuleHandle,NULL
		mov App_Instance,eax
		mov Window_Info.hInstance,eax
		invoke GetModuleHandle,NULL
		mov Dlg_Instance,eax
;		invoke ShowCursor,FALSE
		mov esi,OFFSET Mem_Instance						;; ) obtain a memory instance
		call CreateMemInstance							;; )
		call InitRandomNumbers


;
; obtain the sizes and the center of the OS screen
;
		invoke GetSystemMetrics,SM_CXSCREEN
		mov OS_Screen_Width,eax
		sar eax,1
		mov OS_Screen_Width_Half,eax
		invoke GetSystemMetrics,SM_CYSCREEN
		mov OS_Screen_Height,eax
		sar eax,1
		mov OS_Screen_Height_Half,eax


;
; fill the BITMAPINFO structure (for OUR screen format) with the required values
;
		mov eax,OS_Screen_Width
		mov edx,OS_Screen_Height
		neg edx										;; neg, so the first line will be the top one
		mov Work_Screens_Bmp_Info.biSize,SIZEOF BITMAPINFOHEADER
		mov Work_Screens_Bmp_Info.biWidth,eax
		mov Work_Screens_Bmp_Info.biHeight,edx
		mov Work_Screens_Bmp_Info.biPlanes,1
		mov Work_Screens_Bmp_Info.biBitCount,32				;; for 32 bits colors
		mov Work_Screens_Bmp_Info.biCompression,BI_RGB		;; (BI_RGB = no compression)
		mov Work_Screens_Bmp_Info.biSizeImage,0
		mov Work_Screens_Bmp_Info.biXPelsPerMeter,0
		mov Work_Screens_Bmp_Info.biYPelsPerMeter,0
		mov Work_Screens_Bmp_Info.biClrUsed,0
		mov Work_Screens_Bmp_Info.biClrImportant,0


;
; fill the WNDCLASSEX structure with the required values
;
		invoke LoadIcon,App_Instance,Rsrc_IDI_Icon_32
		mov Window_Info.hIcon,eax
		invoke LoadCursor,NULL,IDC_ARROW
		mov Window_Info.hCursor,eax
		mov Window_Info.cbSize,SIZEOF WNDCLASSEX
		mov Window_Info.style,CS_BYTEALIGNCLIENT or CS_NOCLOSE
		mov Window_Info.lpfnWndProc,OFFSET WinProc
		mov Window_Info.cbClsExtra,NULL
		mov Window_Info.cbWndExtra,NULL
		mov Window_Info.hbrBackground,COLOR_WINDOWTEXT
		mov Window_Info.lpszMenuName,NULL
		mov Window_Info.lpszClassName,OFFSET str_WindowClass
		mov Window_Info.hIconSm,0
		invoke RegisterClassEx,ADDR Window_Info
; now create the screen
		invoke CreateWindowEx,WS_EX_LEFT,ADDR str_WindowClass,ADDR str_WindowTitle,WS_POPUP,NULL,NULL,OS_Screen_Width,OS_Screen_Height,NULL,NULL,App_Instance,NULL
		mov Pointer_Window,eax


;
; we test the processor to know if the minimum required is here
;
		call ProcessorAbilities
		xor edx,edx
;		mov edx,000000000001b							;; cpuid
;		mov edx,000000000011b							;; cpuid + fpu
;		mov edx,000000000111b							;; cpuid + fpu + rdtsc
;		mov edx,000000001111b							;; cpuid + fpu + rdtsc + cmov
;		mov edx,000000011111b							;; cpuid + fpu + rdtsc + cmov + mmx
		mov edx,000000111111b							;; cpuid + fpu + rdtsc + cmov + mmx + sse
;		mov edx,000001111111b							;; cpuid + fpu + rdtsc + cmov + mmx + sse + sse2
;		mov edx,000011111111b							;; cpuid + fpu + rdtsc + cmov + mmx + sse + sse2 + sse3
		and eax,edx
		cmp eax,edx
		je Init_ProcessorOk
;		invoke ShowCursor,TRUE
		invoke MessageBeep,0FFFFFFFFh
		invoke DialogBoxParam,Dlg_Instance,Rsrc_IDD_Insufficient,0,ADDR DlgWinProc,0
Init_ProcessorMessagesLoop:
;		invoke GetMessage,ADDR OS_Messages,NULL,NULL,NULL
		invoke GetMessage,ADDR OS_Messages,Pointer_Window,NULL,NULL
		cmp eax,NULL
		je End_InsufficientProcessor
;		invoke TranslateMessage,ADDR OS_Messages
		invoke DispatchMessage,ADDR OS_Messages
		jmp Init_ProcessorMessagesLoop
Init_ProcessorOk:


;
; We create a pointer for the device context
;
		invoke GetDC,Pointer_Window
		mov Pointer_DC_Screen,eax


;
; Create the popup menu
;
		invoke LoadMenu,App_Instance,Rsrc_IDM_MainMenu
		invoke GetSubMenu,eax,0							;; get the pointer of the first (0) submenu
		mov Pointer_Main_Menu,eax						;; and save it


;
; Launch the main process
;
		invoke CreateThread,NULL,Main_Process_Stack_Size*1024,ADDR MainProcess,Pointer_Window,NULL,ADDR Pointer_Main_Process
		mov Pointer_Main_Process,eax
		invoke SetThreadPriority,Pointer_Main_Process,THREAD_PRIORITY_NORMAL
		mov Flag_Main_Process,1


;
; activate/display the screen
;
		invoke ShowWindow,Pointer_Window,SW_SHOWNORMAL
		invoke UpdateWindow,Pointer_Window
		invoke SetTimer,Pointer_Window,1,1000,OFFSET TestElapsedTime


;
; Loop to execute until the message from PostQuitMessage hasn't be received
;
MessagesLoop:
		invoke GetMessage,ADDR OS_Messages,Pointer_Window,NULL,NULL
		cmp eax,NULL
		je End_MessagesLoop
		invoke TranslateMessage,ADDR OS_Messages
		invoke DispatchMessage,ADDR OS_Messages
		jmp MessagesLoop
End_MessagesLoop:


;
; And here the exit...
;
End_FastExit:
		invoke KillTimer,Pointer_Window,1
;		invoke SetThreadPriority,Pointer_Main_Process,THREAD_PRIORITY_NORMAL
		invoke TerminateThread,Pointer_Main_Process,0
		invoke DestroyMenu,Pointer_Main_Menu
		invoke DeleteDC,Pointer_DC_Screen
;		invoke SetCursorPos,OS_Screen_Width_Half,OS_Screen_Height_Half
;		invoke ShowCursor,TRUE
End_InsufficientProcessor:
		mov esi,OFFSET Mem_Instance						;; ) we don't need the memory instance anymore...
		call SuppressMemInstance							;; )
;		invoke GetCurrentProcess
;		invoke SetPriorityClass,eax,NORMAL_PRIORITY_CLASS
		invoke ExitProcess,OS_Messages.wParam
;
END TortureHer



